/* This script shows an example of the optimizer correctly estimating the number of rows that 
the query returns.  */

set linesize 1000
set pagesize 1000
set echo on
set termout on

spool test1.log

create table test1 (a number);

/* Insert 10 identical rows */

insert into test1 values(1);
insert into test1 values(1);
insert into test1 values(1);
insert into test1 values(1);
insert into test1 values(1);
insert into test1 values(1);
insert into test1 values(1);
insert into test1 values(1);
insert into test1 values(1);
insert into test1 values(1);

commit;

/* Gather stats compute */

execute DBMS_STATS.GATHER_TABLE_STATS (NULL,'TEST1',cascade=>TRUE,estimate_percent=>NULL,method_opt=>'FOR ALL COLUMNS SIZE 1');

/* Get plan */

explain plan into plan_table for 
select * from test1 where a=1;
/
set echo off
@utlxpls.sql
set echo on

/* Show actual distribution of data */

select a,count(*) from test1 group by a;

/* Show the statistics used to calculate the number of rows.  Low value of column, high value,
number of distinct values */

select UTL_RAW.CAST_TO_NUMBER(low_value) Low,UTL_RAW.CAST_TO_NUMBER(high_value) High,
num_distinct
from USER_TAB_COLUMNS 
where table_name='TEST1' and 
column_name='A';

/* Show the number of rows in the table statistic */

select num_rows
from USER_TABLES 
where table_name='TEST1';

drop table test1;

spool off
